﻿CREATE FUNCTION "PMX_FN_GetNextLocation_PutAway" (
	p_itemCode nvarchar(50)
)
RETURNS TABLE ( BinLocation nvarchar(50) )
LANGUAGE SQLSCRIPT AS

BEGIN

	DECLARE v_returnBinCode nvarchar(50); 
	DECLARE v_returnSequence int;
	DECLARE v_returnMaxLogUnits int;
	DECLARE v_returnCurrentPallets int;
	DECLARE v_returnCurrentStock int;
	DECLARE v_returnSequenceOfHomeLocation int;
	DECLARE v_returnAbsDistancetoLocation int;

	select top 1 PMX_OSSL."Code"
	, PMX_OSSL."Sequence"
	, PMX_OSSL."MaxLogUnits"

	,count(PMX_INVT."SSCC")as "CurrentPallets" 
	,sum(PMX_INVT."Quantity") as "CurrentStock" 
	,HOMEBIN."Sequence" as "SequenceOfHomeLocation"
	,abs(PMX_OSSL."Sequence" - HOMEBIN."Sequence") as "AbsDistancetoLocation" into v_returnBinCode,v_returnSequence,v_returnMaxLogUnits,v_returnCurrentPallets,v_returnCurrentStock,
	v_returnSequenceOfHomeLocation,v_returnAbsDistancetoLocation
	
	from PMX_OSSL
	left join PMX_INVT on PMX_INVT."StorLocCode" = PMX_OSSL."Code"
	join OITM on OITM."ItemCode" = p_itemCode
	join PMX_OSSL HOMEBIN on HOMEBIN."Code" = OITM."U_PMX_DSLC"
	join PMX_OSEL HOMEBINOSEL on HOMEBINOSEL."Code" = HOMEBIN."Code"
	join PMX_OSEL on PMX_OSEL."Code" = PMX_OSSL."Code"
	
	where PMX_OSSL."IsActive" = 'Y' and PMX_OSEL."TypeCode"='BIN' and PMX_OSSL."Code" <> OITM."U_PMX_DSLC" and PMX_OSSL."IsPickLoc" = 'N'
	
	and PMX_OSSL."Code" not in (select PMX_MOLI."DestStorLocCode" from pmx_mohe
								join PMX_MOLI on PMX_MOLI."DocEntry" = PMX_MOHE."DocEntry"
								where PMX_MOHE."MoveOrderType" = 'M' and PMX_MOHE."DocStatus" = 'O' and PMX_MOLI."ItemCode" = OITM."ItemCode")
	and HOMEBINOSEL."PmxWhsCode" = PMX_OSEL."PmxWhsCode"
	and PMX_OSEL."ParentCode" not in (select "Code" from pmx_osel
								where "Code" = 'QRM-REDTAG' or "ParentCode" = 'QRM-REDTAG')
	
	group by PMX_OSSL."Code", PMX_OSSL."Sequence", PMX_OSSL."MaxLogUnits",HOMEBIN."Sequence"
	
--having (PMX_OSSL."MaxLogUnits" - (count(PMX_INVT.SSCC))) >0
-- no longer valide for cut over: during cut over we won't have sscc's so we have to check on quantity
	having ifnull(sum(PMX_INVT."Quantity"),0) <=0
	
	order by "AbsDistancetoLocation","CurrentPallets" desc,PMX_OSSL."Sequence",PMX_OSSL."Code";
	

	RETURN SELECT v_returnBinCode AS BinLocation FROM dummy;

END;